searchNodes=[{"doc":"EarmarkAstDsl is a toolset to generate EarmarkParser conformant AST Nodes.Its main purpose is to remove boilerplate code from Earmark and EarmarkParser tests. Documentation for EarmarkAstDsl.tagThe most general helper is the tag function:iex(1)&gt; tag(&quot;div&quot;, &quot;Some content&quot;) {&quot;div&quot;, [], [&quot;Some content&quot;]}Content and attributes can be provided as arrays, ...iex(2)&gt; tag(&quot;p&quot;, ~w[Hello World], class: &quot;hidden&quot;) {&quot;p&quot;, [{&quot;class&quot;, &quot;hidden&quot;}], [&quot;Hello&quot;, &quot;World&quot;]}... or maps:iex(3)&gt; tag(&quot;p&quot;, ~w[Hello World], %{class: &quot;hidden&quot;}) {&quot;p&quot;, [{&quot;class&quot;, &quot;hidden&quot;}], [&quot;Hello&quot;, &quot;World&quot;]}Shortcuts for p and diviex(4)&gt; p(&quot;A para&quot;) {&quot;p&quot;, [], [&quot;A para&quot;]} iex(5)&gt; div(tag(&quot;span&quot;, &quot;content&quot;)) {&quot;div&quot;, [], [{&quot;span&quot;, [], [&quot;content&quot;]}]}","ref":"EarmarkAstDsl.html","title":"EarmarkAstDsl","type":"module"},{"doc":"","ref":"EarmarkAstDsl.html#div/2","title":"EarmarkAstDsl.div/2","type":"function"},{"doc":"","ref":"EarmarkAstDsl.html#p/2","title":"EarmarkAstDsl.p/2","type":"function"},{"doc":"TablesTables are probably the raison d'être ot this little lib, as their ast is quite verbose, as we will see here:iex(6)&gt; table(&quot;one cell only&quot;) # and look at the output {&quot;table&quot;, [], [ {&quot;tbody&quot;, [], [ {&quot;tr&quot;, [], [ {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;one cell only&quot;]} ]} ]} ]}Now if we want a header and have some more data:iex(7)&gt; table([~w[1-1 1-2], ~w[2-1 2-2]], head: ~w[left right]) # This is quite verbose! {&quot;table&quot;, [], [ {&quot;thead&quot;, [], [ {&quot;tr&quot;, [], [ {&quot;th&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;left&quot;]}, {&quot;th&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;right&quot;]}, ]} ]}, {&quot;tbody&quot;, [], [ {&quot;tr&quot;, [], [ {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;1-1&quot;]}, {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;1-2&quot;]}, ]}, {&quot;tr&quot;, [], [ {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;2-1&quot;]}, {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;2-2&quot;]}, ]} ]} ]}And tables can easily be aligned differently in Markdown, which makes some style helpers very usefuliex(8)&gt; table([~w[1-1 1-2], ~w[2-1 2-2]], ...(8)&gt; head: ~w[alpha beta], ...(8)&gt; text_aligns: ~w[right center]) {&quot;table&quot;, [], [ {&quot;thead&quot;, [], [ {&quot;tr&quot;, [], [ {&quot;th&quot;, [{&quot;style&quot;, &quot;text-align: right;&quot;}], [&quot;alpha&quot;]}, {&quot;th&quot;, [{&quot;style&quot;, &quot;text-align: center;&quot;}], [&quot;beta&quot;]}, ]} ]}, {&quot;tbody&quot;, [], [ {&quot;tr&quot;, [], [ {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: right;&quot;}], [&quot;1-1&quot;]}, {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: center;&quot;}], [&quot;1-2&quot;]}, ]}, {&quot;tr&quot;, [], [ {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: right;&quot;}], [&quot;2-1&quot;]}, {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: center;&quot;}], [&quot;2-2&quot;]}, ]} ]} ]} Some leeway is given for the determination of the number of columns, bear in mind that Markdown only supports regularly shaped tables with a fixed number of columns. Problems might arise when we have a table like the following | alpha | | beta *gamma* | where the first cell contains one element, but the second two, we can hint that we only want one by grouping into tuples iex(9)&gt; table([&quot;alpha&quot;, {&quot;beta&quot;, tag(&quot;em&quot;, &quot;gamma&quot;)}]) {&quot;table&quot;, [], [ {&quot;tbody&quot;, [], [ {&quot;tr&quot;, [], [ {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;alpha&quot;]}, ]}, {&quot;tr&quot;, [], [ {&quot;td&quot;, [{&quot;style&quot;, &quot;text-align: left;&quot;}], [&quot;beta&quot;, {&quot;em&quot;, [], [&quot;gamma&quot;]}]} ]} ]} ]}","ref":"EarmarkAstDsl.html#table/2","title":"EarmarkAstDsl.table/2","type":"function"},{"doc":"","ref":"EarmarkAstDsl.html#tag/3","title":"EarmarkAstDsl.tag/3","type":"function"},{"doc":"","ref":"EarmarkAstDsl.html#t:ast_node/0","title":"EarmarkAstDsl.ast_node/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:ast_t/0","title":"EarmarkAstDsl.ast_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:ast_ts/0","title":"EarmarkAstDsl.ast_ts/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:att_list/0","title":"EarmarkAstDsl.att_list/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:att_t/0","title":"EarmarkAstDsl.att_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:att_ts/0","title":"EarmarkAstDsl.att_ts/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:binaries/0","title":"EarmarkAstDsl.binaries/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:content_t/0","title":"EarmarkAstDsl.content_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:free_atts_t/0","title":"EarmarkAstDsl.free_atts_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:matrix_t/0","title":"EarmarkAstDsl.matrix_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:maybe/1","title":"EarmarkAstDsl.maybe/1","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:row_t/0","title":"EarmarkAstDsl.row_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:scalar_t/0","title":"EarmarkAstDsl.scalar_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:table_t/0","title":"EarmarkAstDsl.table_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:vector_t/0","title":"EarmarkAstDsl.vector_t/0","type":"type"}]